function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { AppBar, Divider, Drawer, Fab, FormControl, IconButton, Toolbar, Select, MenuItem, Typography } from '@mui/material';
import { Add, ClearAll, SortByAlpha, Close, Delete } from '@mui/icons-material';
import { useFilter } from '../../providers/Filter';
import { useIntl } from 'react-intl';
import Scrollbar from '../../components/Scrollbar';
export default function (_ref) {
  var name = _ref.name,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? 250 : _ref$width,
      _ref$fields = _ref.fields,
      fields = _ref$fields === void 0 ? [] : _ref$fields;
  var intl = useIntl();

  var _useFilter = useFilter(),
      isFilterOpen = _useFilter.isFilterOpen,
      closeFilter = _useFilter.closeFilter,
      clearFilter = _useFilter.clearFilter,
      getFilter = _useFilter.getFilter,
      removeFilterQuery = _useFilter.removeFilterQuery,
      editFilterQuery = _useFilter.editFilterQuery,
      addFilterQuery = _useFilter.addFilterQuery,
      setFilterSortField = _useFilter.setFilterSortField,
      setFilterSortOrientation = _useFilter.setFilterSortOrientation,
      getField = _useFilter.getField;

  var _getFilter = getFilter(name),
      _getFilter$queries = _getFilter.queries,
      queries = _getFilter$queries === void 0 ? [] : _getFilter$queries,
      _getFilter$sortField = _getFilter.sortField,
      sortField = _getFilter$sortField === void 0 ? '' : _getFilter$sortField,
      _getFilter$sortOrient = _getFilter.sortOrientation,
      sortOrientation = _getFilter$sortOrient === void 0 ? 1 : _getFilter$sortOrient;

  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Drawer, {
    variant: "persistent",
    anchor: "right",
    open: isFilterOpen(name)
  }, /*#__PURE__*/React.createElement(AppBar, {
    position: "static"
  }, /*#__PURE__*/React.createElement(Toolbar, {
    disableGutters: true
  }, /*#__PURE__*/React.createElement(IconButton, {
    color: "inherit",
    onClick: function onClick() {
      return closeFilter(name);
    }
  }, /*#__PURE__*/React.createElement(Close, null)), /*#__PURE__*/React.createElement(Typography, {
    variant: "h6",
    color: "inherit"
  }, intl.formatMessage({
    id: 'filter',
    defaultMessage: 'Filter'
  })), /*#__PURE__*/React.createElement("div", {
    style: {
      flex: 1
    }
  }), /*#__PURE__*/React.createElement(IconButton, {
    color: "inherit",
    onClick: function onClick() {
      return clearFilter(name);
    }
  }, /*#__PURE__*/React.createElement(ClearAll, null)))), /*#__PURE__*/React.createElement("div", {
    style: {
      width: width,
      display: 'flex',
      flexDirection: 'column',
      height: '100%'
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      margin: 8,
      display: 'flex',
      flexDirection: 'row'
    }
  }, /*#__PURE__*/React.createElement(FormControl, {
    variant: "outlined",
    fullWidth: true,
    style: {
      padding: 1
    }
  }, /*#__PURE__*/React.createElement(Select, {
    value: sortField,
    onChange: function onChange(e) {
      setFilterSortField(name, e.target.value);
    },
    displayEmpty: true
  }, /*#__PURE__*/React.createElement(MenuItem, {
    key: 'none',
    value: ''
  }, intl.formatMessage({
    id: 'none',
    defaultMessage: 'None'
  })), fields.map(function (f) {
    return /*#__PURE__*/React.createElement(MenuItem, {
      key: f.name,
      value: f.name
    }, f.label);
  }))), /*#__PURE__*/React.createElement(IconButton, {
    color: sortOrientation === 1 ? 'primary' : 'secondary',
    disabled: sortField === '' || !sortField,
    onClick: function onClick() {
      return setFilterSortOrientation(name, sortOrientation === 1 ? -1 : 1);
    }
  }, /*#__PURE__*/React.createElement(SortByAlpha, null))), /*#__PURE__*/React.createElement(Divider, null), /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      flexDirection: 'row',
      flexWrap: 'nowrap',
      alignItems: 'center',
      justifyContent: 'space-between',
      padding: 8
    }
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "h6",
    color: "inherit"
  }, intl.formatMessage({
    id: 'filter',
    defaultMessage: 'Filter'
  })), /*#__PURE__*/React.createElement(Fab, {
    size: "small",
    onClick: function onClick() {
      return addFilterQuery(name, {
        field: '',
        operator: '=',
        value: ''
      });
    },
    color: "primary",
    "aria-label": "add"
  }, /*#__PURE__*/React.createElement(Add, null))), /*#__PURE__*/React.createElement("div", {
    style: {
      height: '100%',
      flex: 1
    }
  }, /*#__PURE__*/React.createElement(Scrollbar, null, queries.map(function (q, i) {
    var field = getField(q.field, fields);
    return /*#__PURE__*/React.createElement("div", {
      key: q.field + "_" + i,
      style: {
        padding: 8
      }
    }, /*#__PURE__*/React.createElement(FormControl, {
      variant: "outlined",
      fullWidth: true,
      style: {
        padding: 1
      }
    }, /*#__PURE__*/React.createElement(Select, {
      value: q.field,
      onChange: function onChange(e) {
        var _getField = getField(e.target.value, fields),
            defaultOperator = _getField.defaultOperator;

        return editFilterQuery(name, i, _extends({}, q, {
          field: e.target.value,
          operator: defaultOperator
        }));
      },
      displayEmpty: true
    }, fields.map(function (f) {
      return /*#__PURE__*/React.createElement(MenuItem, {
        key: f.name,
        value: f.name
      }, f.label);
    }))), /*#__PURE__*/React.createElement("div", {
      style: {
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'space-between'
      }
    }, field && /*#__PURE__*/React.createElement(FormControl, {
      variant: "outlined",
      style: {
        padding: 1,
        minWidth: 100
      }
    }, /*#__PURE__*/React.createElement(Select, {
      value: q.operator,
      onChange: function onChange(e) {
        return editFilterQuery(name, i, _extends({}, q, {
          operator: e.target.value
        }));
      },
      displayEmpty: true
    }, field.operators.map(function (o) {
      return /*#__PURE__*/React.createElement(MenuItem, {
        key: o.value,
        value: o.value
      }, o.label);
    }))), /*#__PURE__*/React.createElement(IconButton, {
      onClick: function onClick() {
        return removeFilterQuery(name, i);
      }
    }, /*#__PURE__*/React.createElement(Delete, {
      color: "error"
    }))), field && field.render(q, function (changes) {
      return editFilterQuery(name, i, _extends({}, q, changes));
    }), /*#__PURE__*/React.createElement(Divider, {
      style: {
        marginTop: 6
      }
    }));
  }))))));
}