function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useContext } from 'react';
import { useTheme as useAppTheme } from '../../providers/Theme';
import MenuContext from '../../providers/Menu/Context';
import { useTheme } from '@mui/material/styles';
import { useConfig } from 'base-shell/lib/providers/Config';
import { useOnline } from 'base-shell/lib/providers/Online';
import { useIntl } from 'react-intl';
import { AppBar, Toolbar, IconButton, LinearProgress, Typography } from '@mui/material';
import { ChevronLeft, Menu as MenuIcon } from '@mui/icons-material';
export default function (_ref) {
  var children = _ref.children,
      pageTitle = _ref.pageTitle,
      onBackClick = _ref.onBackClick,
      isLoading = _ref.isLoading,
      _ref$appBarContent = _ref.appBarContent,
      appBarContent = _ref$appBarContent === void 0 ? null : _ref$appBarContent,
      contentStyle = _ref.contentStyle,
      _ref$tabs = _ref.tabs,
      tabs = _ref$tabs === void 0 ? null : _ref$tabs;

  var _useAppTheme = useAppTheme(),
      isRTL = _useAppTheme.isRTL;

  var isOnline = useOnline();
  var theme = useTheme();

  var _useConfig = useConfig(),
      appConfig = _useConfig.appConfig;

  var _ref2 = appConfig || {},
      menu = _ref2.menu;

  var _ref3 = menu || {},
      _ref3$width = _ref3.width,
      width = _ref3$width === void 0 ? 240 : _ref3$width,
      _ref3$appBarLeadingCo = _ref3.appBarLeadingContent,
      appBarLeadingContent = _ref3$appBarLeadingCo === void 0 ? null : _ref3$appBarLeadingCo;

  var _useContext = useContext(MenuContext),
      toggleThis = _useContext.toggleThis,
      isDesktop = _useContext.isDesktop,
      isMenuOpen = _useContext.isMenuOpen;

  var intl = useIntl();
  var headerTitle = '';

  if (typeof pageTitle === 'string' || pageTitle instanceof String) {
    headerTitle = pageTitle;
  }

  var handleDrawerMenuClick = function handleDrawerMenuClick() {
    if (!isMenuOpen) {
      toggleThis('isMiniMode', false);
      toggleThis('isMenuOpen', true);

      if (!isDesktop) {
        toggleThis('isMobileMenuOpen');
      }
    } else {
      toggleThis('isMobileMenuOpen');
    }
  };

  return /*#__PURE__*/React.createElement("div", {
    style: {
      width: '100%',
      display: 'flex',
      flexDirection: 'column',
      height: '100vh',
      overflow: 'hidden'
    }
  }, /*#__PURE__*/React.createElement(AppBar, {
    position: isDesktop ? 'absolute' : undefined,
    sx: {
      width: isMenuOpen && isDesktop ? "calc(100% - " + width + "px)" : undefined,
      zIndex: theme.zIndex['drawer'],
      transition: theme.transitions.create(['width', 'margin'], {
        easing: theme.transitions.easing.sharp,
        duration: theme.transitions.duration.leavingScreen
      }),
      maxHeight: 64,
      marginLeft: isRTL ? 0 : -12,
      marginRight: isRTL ? 30 : 0
    }
  }, /*#__PURE__*/React.createElement(Toolbar, null, isMenuOpen && isDesktop || !onBackClick && /*#__PURE__*/React.createElement(IconButton, {
    color: "inherit",
    "aria-label": "open drawer",
    onClick: handleDrawerMenuClick,
    edge: "start"
  }, /*#__PURE__*/React.createElement(MenuIcon, null)), onBackClick && /*#__PURE__*/React.createElement(IconButton, {
    color: "inherit",
    "aria-label": "open drawer",
    onClick: onBackClick
  }, /*#__PURE__*/React.createElement(ChevronLeft, null)), !onBackClick && isMenuOpen && false && /*#__PURE__*/React.createElement("div", {
    style: {
      marginRight: 32
    }
  }), appBarLeadingContent, /*#__PURE__*/React.createElement(Typography, {
    variant: "h6",
    color: "inherit",
    noWrap: true
  }, headerTitle), /*#__PURE__*/React.createElement("div", {
    style: {
      flex: '1 1 auto'
    }
  }), appBarContent)), /*#__PURE__*/React.createElement("div", {
    style: {
      alignItems: 'center',
      justifyContent: 'flex-end',
      //...theme.mixins.toolbar,
      minHeight: 64 //height of AppBar

    }
  }), isLoading && /*#__PURE__*/React.createElement(LinearProgress, null), !isOnline && /*#__PURE__*/React.createElement("div", {
    style: {
      display: 'flex',
      justifyContent: 'center',
      width: '100%',
      height: 15,
      backgroundColor: theme.palette.secondary.main
    }
  }, /*#__PURE__*/React.createElement(Typography, {
    variant: "caption",
    color: "textSecondary",
    noWrap: true
  }, intl.formatMessage({
    id: 'offline',
    defaultMessage: 'Offline'
  }))), tabs, /*#__PURE__*/React.createElement("div", {
    style: _extends({
      flex: 1,
      overflow: 'auto'
    }, contentStyle)
  }, children));
}